function run( this, s )

% State = run( this, settings )
%
% Valid fields in settings:
%   .init_groups   Settings for the 'init_groups' method, see its help
%                  section for details.
%   .tune_groups   Settings for the 'tune_groups' method, see its help
%                  section for details.
%
% Throws in specified amount of random variables (def=all) with
% method 'init_groups', then processes the grouping with method 'tune_groups'.
%
% If the given State contains already active variables, then the
% 'init_groups' phase will be skipped.


%  This file is a part of the Independent Variable Group Analysis package
% 
%  Copyright (C) 2001-2006 Esa Alhoniemi, Antti Honkela, Krista Lagus,
%  Jeremias Seppa, Harri Valpola, and Paul Wagner
% 
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
% 
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License (included in file License.txt in the
%  program package) for more details.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global STATS State;


% init groups
if isempty( State.vars )
  this = init_groups( this, s.init_groups );
end

% tune groups
this = tune_groups( this, s.tune_groups );

% sanity check
sanity_check( this, State, [] );


return;
