function [running, active_jobs, active_workers] = query_system( this )


%  This file is a part of the Independent Variable Group Analysis package
% 
%  Copyright (C) 2001-2006 Esa Alhoniemi, Antti Honkela, Krista Lagus,
%  Jeremias Seppa, Harri Valpola, and Paul Wagner
% 
%  This program is free software; you can redistribute it and/or modify
%  it under the terms of the GNU General Public License as published by
%  the Free Software Foundation; either version 2, or (at your option)
%  any later version.
% 
%  This program is distributed in the hope that it will be useful,
%  but WITHOUT ANY WARRANTY; without even the implied warranty of
%  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%  GNU General Public License (included in file License.txt in the
%  program package) for more details.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

running = []; active_jobs = []; active_workers = [];


running = environment( 'get_system_load' );
if isnan( running )
  if ~this.quiet, warning('Unable to query system status!'); end
  running = Inf;
end

% count active jobs and workers
jobs = dir([ this.commdir 'parajob_*.mat' ])';
active_jobs = size( jobs, 2 );
active_workers = 0;
for job=jobs
  if length(strfind( job.name, '_' )) == 2
    active_workers = active_workers + 1;
  end
end


return;
